
#include 'AppEvent.ch'
#include "Common.ch"
#include "Dll.ch"
#include 'Set.ch'
#include 'Xbp.Ch'
#include 'Misc.ch'

#define CR                     Chr(13)
Procedure Main()
LOCAL cFolderSelected, oDlg, oOldApp, oOldFocus, cDisplayName
oDlg := XbpDialog():new(,,,{800,600})
oDlg:title := 'TESTING FOLDER SELECTION'
oDlg:tasklist := .t.
oDlg:create()
oDlg:drawingArea:setColorBG(GraMakeRGBColor({255,230,230}))
CenterControl(oDlg)
oOldApp   := SetAppWindow(oDlg:drawingArea)
oOldFocus := SetAppFocus()
do while .t.
   if ConfirmBox(NIL, 'Starting the Selection?',;
                      'SELECTING FOLDER, COMPUTER AND PRINTER') <> 1
      exit
   endif

   cDisplayName := CabSelectFolder_(oDlg:drawingArea, "Folder Selection using DEFAULTs", '', @cFolderSelected)
   if      Empty(cFolderSelected)
           ConfirmBox(NIL, 'Nothing was Selected',;
                           'BROWSE RESULT', XBPMB_OK, (XBPMB_INFORMATION + XBPMB_APPMODAL + XBPMB_MOVEABLE))
   elseif !FExists(cFolderSelected, 'D')
          ConfirmBox(NIL, 'Unknown Folder Selected:' + Chr(13) +;
                          cFolderSelected,;
                           'BROWSE RESULT', XBPMB_OK, (XBPMB_INFORMATION + XBPMB_APPMODAL + XBPMB_MOVEABLE))
   else
          Confirmbox(NIL, ('Selected Folder: ' + cFolderSelected + Chr(13) +;
                           '        DisPlayName: ' + cDisplayName),;
                           'BROWSE RESULT', XBPMB_OK, (XBPMB_INFORMATION + XBPMB_APPMODAL + XBPMB_MOVEABLE))
   endif

   cabSELECTCOMPUTER COMPUTER          cFolderSelected;     // Result: name of the selected computer
                     DISPLAYNAME       cDisplayName;
                     WINDOW            NIL;                 // Default SetAppWindow()
                     CAPTION          'TESTING COMPUTER SELECTION';
                     INCLUDEHINT      .t.;
                     VALIDATE         .t.;
                     RECURSOSSERVIDOR .f.;
                     EXIBIRURLS       .t.
   if      Empty(cFolderSelected)
           ConfirmBox(NIL, 'Nothing was selected', ;
                           'BROWSE RESULT', XBPMB_OK, (XBPMB_INFORMATION + XBPMB_APPMODAL + XBPMB_MOVEABLE))
   else
          Confirmbox(NIL, ('Selected Computer: ' + cFolderSelected + Chr(13) +;
                           '            DisPlayName: ' + cDisplayName),;
                           'BROWSE RESULT', XBPMB_OK, (XBPMB_INFORMATION + XBPMB_APPMODAL + XBPMB_MOVEABLE))
   endif

   cabSELECTPRINTER PRINTER           cFolderSelected;      // Result: name of the selected printer
                    DISPLAYNAME       cDisplayName;
                    WINDOW            NIL;
                    CAPTION           'TESTING PRINTER SELECTION';
                    INCLUDEHINT       .f.;
                    HASEDITBOX        .t.;
                    VALIDATE          .t.;
                    EXIBIRURLS        .t.
   if      Empty(cFolderSelected)
           ConfirmBox(NIL, 'Nothing was Selected',;
                           'BROWSE RESULT', XBPMB_OK, (XBPMB_INFORMATION + XBPMB_APPMODAL + XBPMB_MOVEABLE))
   else
          Confirmbox(NIL, ('Selected Printer: ' + cFolderSelected + Chr(13) +;
                           '                   DisPlayName: ' + cDisplayName),;
                           'BROWSE RESULT', XBPMB_OK, (XBPMB_INFORMATION + XBPMB_APPMODAL + XBPMB_MOVEABLE))
   endif
enddo
SetAppWindow(oOldApp)
SetAppFocus(oOldFocus)
RETURN

PROCEDURE AppSys()
          Set(_SET_CHARSET, CHARSET_ANSI)
RETURN

 ////////////
 //
FUNCTION ApiLoadDll_(cDll)
 //               <cDll> -> DLL to load
 //      Returns the <cDll> handle
 //
 /////
STATIC aDllLoaded := {}                  // Loaded Dlls: {{cDllName, nDllHandle}, ...}
LOCAL  nDllHandle

cDll := Lower(AllTrim(cDll))
if Right(cDll, 4) <> '.dll'
   cDll           += '.dll'
endif

nDllHandle    := AScan(aDllLoaded, {|x| x[01] == cDll})
if nDllHandle  > 0
   nDllHandle := aDllLoaded[nDllHandle, 02]
else
   nDllHandle := DllLoad(cDll)
   AAdd(aDllLoaded, {cDll, nDllHandle})
endif
RETURN nDllHandle

#pragma library( "ASCOM10.LIB" )
 ///////////
 //
FUNCTION  CabSelectFolder_(oWin, cCaption,                   xRootDir,           cFolderSelected,;
                                 lIncludeHint,               lEditBox,           lValidate,;
                                 lIncludeShareableResources, lIncludeOnlyFSDirs, lIncludeURLs,;
                                 lOnlyComputers,             lOnlyPrinters,      lCanCreateFolder)
 //       Dialog for browsing folders, computers and printers
 //                [<oWin>]
 //                [<cCaption>]                   -> Internal browse window title
 //                                                  Default:
 //                                                  . if <lOnlyComputers> == .t. =: 'COMPUTER SELECTION'
 //                                                  . if <lOnlyPrinters>  == .t. := 'PRINTER SELECTION''
 //                                                  . other cases                := 'FOLDER SELECTION'
 //                [<xRootDir>]                   -> Root folder
 //                                                  Only <xRootDir> and its folders are selected
 //                                                  May be user defined or any CSIDL_... defined
 //                                                  in Misc.ch
 //                                                  Default:
 //                                                  . if <lOnlyComputers> == .t. := CCSIDL_COMPUTERSNEARME
 //                                                  . if <lOnlyPrinters>  == .t. := CSIDL_PRINTERS
 //                                                  . other cases         := '' (exibir todos os folders)
 //                [@<cFolderSelected>]           -> selected folder or empty string
 //                                                  Se nenhuma seleo foi feita conter ''
 //                [<lIncludeHint>]               -> Default .f.
 //                [<lEditBox>]                   -> Default .t.
 //                [<lValidate>]                  -> Default .t.
 //                [<lIncludeShareableResources>] -> Default .t.
 //                [<lIncludeOnlyFSDirs>]         -> Default .t.
 //                [<lIncludeURLs>]               -> Default .f.
 //                [<lOnlyComputers>]             -> Default .f.
 //                [<lOnlyPrinters>]              -> Default .f.
 //                [<lCanCreateFolder>]           -> Default .f.
 //       Retorn: . if the selection was ok:
 //                 .. Updates @<cFolderSelected>] with the item selected
 //                 .. Returns the "display name" of @<cFolderSelected>
 //               . if had an error:
 //                  .. @<cFolderSelected> will have an empty string
 //                  .. return an empty string
 /////
LOCAL  oOldAppWindow, oOldFocus, nHWND,   nFlags, bOldError, e, oShell, oFolder, oFolderItem,;
       cDisplayName,  nOldSet,   lRepeat, cMens

oOldAppWindow := SetAppWindow()
oOldFocus     := SetAppFocus()

if oWin  <> NIL
   nHWND := oWin:getHWND()
else
   nHWND := SetAppWindow():getHWND()
endif

nFlags                    := BIF_NEWDIALOGSTYLE
if lIncludeHint           <> NIL .and.;
   lIncludeHint
   nFlags                 += BIF_UAHINT
   lEditBox               := .f.
endif

if     lOnlyComputers     <> NIL .and.;
       lOnlyComputers
       if cCaption        == NIL
          cCaption        := 'COMPUTER SELECTION'
       endif
       if xRootDir        == NIL
          xRootDir        := CSIDL_COMPUTERSNEARME
       endif
       nFlags             += BIF_BROWSEFORCOMPUTER
       lIncludeOnlyFSDirs := .t.
       lOnlyPrinters      := .f.
       lCanCreateFolder   := .f.
elseif lOnlyPrinters      <> NIL .and.;
       lOnlyPrinters
       if cCaption        == NIL
          cCaption        := 'PRINTER SELECTION'
       endif
       if xRootDir        == NIL
          xRootDir        := CSIDL_PRINTERS
       endif
       nFlags             += BIF_BROWSEFORPRINTER
       lCanCreateFolder   := .f.
else
       if cCaption        == NIL
          cCaption        := 'FOLDER SELECTION'
       endif
       if xRootDir == NIL
          xRootDir := ''
      endif
endif

if lEditBox                   == NIL .or.;
   lEditBox
   nFlags                     += BIF_EDITBOX
endif
if lValidate                  == NIL .or.;
   lValidate
   nFlags                     += BIF_VALIDATE
endif
if lIncludeShareableResources == NIL .or.;
   lIncludeShareableResources
   nFlags                     += BIF_SHAREABLE
endif

if lIncludeOnlyFSDirs         == NIL .or.;
   lIncludeOnlyFSDirs
   nFlags                     += BIF_RETURNONLYFSDIRS
endif

if lIncludeURLs               <> NIL .and.;
   lIncludeURLs
   nFlags                     += BIF_BROWSEINCLUDEURLS
endif
if lCanCreateFolder           == NIL .or.;
   !lCanCreateFolder
   nFlags                     += BIF_NONEWFOLDERBUTTON
endif

lRepeat   := .t.
bOldError := ErrorBlock({|e| Break(e)})
Do while lRepeat
   cDisplayName    := ''
   cFolderSelected := ''
   BEGIN SEQUENCE
         oShell     := CreateObject("Shell.Application")
         oFolder    := oShell:BrowseForFolder(nHWND, cCaption, nFlags, xRootDir)
         if oFolder <> NIL
            oFolderItem := oFolder:Self
                  // (Do not convert FS paths)
            nOldSet            := Set(_SET_CHARSET, CHARSET_ANSI)
            cFolderSelected    := oFolderItem:Path

            Set(_SET_CHARSET, nOldset)

            cDisplayName         := oFolderItem:Name
            if Set(_SET_CHARSET) == CHARSET_OEM
               cDisplayName      := ConvToOemCp(cDisplayName)
            endif
         endif
         lRepeat := .f.
   RECOVER USING e
           if !Empty(e:genCode)
               cMens := ('Error: '+ e:description)
           else
               cMens := 'Invlid option'
           endif
           cMens += (CR + 'Retry?')
           if Set(_SET_CHARSET) == CHARSET_OEM
              cMens             := ConvToOemCp(cMens)
           endif

           if ConfirmBox(NIL, cMens,;
                             'ERROR FOUND',;
                             XBPMB_OKCANCEL,;
                             (XBPMB_CRITICAL + XBPMB_APPMODAL + XBPMB_MOVEABLE)) <> 1
              lRepeat := .f.
           endif
      ENDSEQUENCE
enddo
errorBlock(bOldError)
SetAppWindow(oOldAppWindow)
SetAppFocus(oOldFocus)
RETURN cDisplayName
